﻿package {
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.geom.Point;
	import flash.geom.ColorTransform;
	import flash.geom.*;



	public class Abstracter extends Sprite {
		//private var d:Number;
		//private var alpha:Number;

		private var offsets:Array=[];
		private var offsetspeed1:Number= 2.0;
		private var offsetspeed2:Number= -2.0;

		private var noiseSeed:int=1000;
		private var baseX:int=180;
		private var baseY:int=180;


		private var renderBMD:BitmapData;
		private var noiseBMD:BitmapData;
		private var renderBMP:Bitmap;
		private var noiseBMP:Bitmap;
		private var brightness:Number;
		private var pixel:int;

		private var red:Number=0;
		private var green:Number=200;
		private var blue:Number=0;

		private var mozaic:Sprite;
		private var angle:Number;
		private var radius,dx,dy:Number;

		private var tile:Sprite;
		private var gridSize:Number=20;
		
		private var redy:Number = 200;
		private var bluy:Number = 100;


		public function Abstracter() {
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		}

		private function downHandler(e:MouseEvent):void {
			noiseSeed += Math.random()*1000;
			redy = Math.random()*60;
			bluy = Math.random()*60;
			
			stage.removeEventListener(MouseEvent.MOUSE_DOWN,downHandler);
			removeEventListener(Event.ENTER_FRAME,enterHandler);
			while(numChildren>0){
				this.removeChildAt(0);
			}
			noiseBMD = null;
			
			
			addedHandler(null);
			
		}

		private function addedHandler(e:Event):void {
			
			stage.addEventListener(MouseEvent.MOUSE_DOWN, downHandler);
			
			offsets.push( new Point() );
			offsets.push( new Point() );

			//noiseSeed = Math.random() * 1000 << 0;

			noiseBMD=new BitmapData(stage.stageWidth,stage.stageHeight,false);
			noiseBMP=new Bitmap(noiseBMD);
			noiseBMP.visible=false;
			addChild( noiseBMP );

			//mozaic = new Sprite;
			//addChild(mozaic);

			/*for(var i:Number=0;i<nbr;i++){
			var ball:Ball = new Ball();
			ball.x = Math.random()*600;
			ball.name = "ball"+i;
			addChild(ball);
			}*/

			for (var i:Number = 0; i < stage.stageWidth; i += gridSize) {
				for (var j:Number = 0; j < stage.stageHeight; j += gridSize) {

					tile = new Sprite();
					//tile.x = i;
					//tile.y = j;
					tile.x = stage.stageWidth/2;
					tile.y = stage.stageHeight/2;
					tile.graphics.beginFill(0x111111,.4);
					
					tile.graphics.drawCircle(i,j, 10);
					tile.graphics.drawCircle(2-i,j, 10);
					tile.graphics.drawCircle(i,2-j, 10);
					tile.graphics.drawCircle(2-i,2-j, 10);
					
					tile.name='tile'+i+j;
					addChild(tile);

				}
			}
			addEventListener(Event.ENTER_FRAME, enterHandler);

		}

		private function enterHandler(e:Event):void {
			
			// Color Factor
			red = mouseX / redy;
			green = 200;
			blue= 400 / bluy;


			offsets[0].x += offsetspeed1 * (stage.stageWidth/2 - mouseX) / 30;
			offsets[0].y += offsetspeed1 * (stage.stageHeight/2 - mouseY) / 30;
			offsets[1].x+=offsetspeed2;
			offsets[1].y+=offsetspeed2;

			noiseBMD.perlinNoise( baseX, baseY, 2, noiseSeed, false, true, 10, true, offsets);

			//tile.graphics.clear();

			//graphics.lineStyle(1,0xff0000,0.1);


			for (var i:Number = 0; i < stage.stageWidth; i += gridSize) {
				for (var j:Number = 0; j < stage.stageHeight; j += gridSize) {
					
					//merci Lionel
					//le getChildByName retourne à la base un displayObject;
					//ce qui explique la présence de Sprite(getChildByName())
					var ball:Sprite = Sprite(getChildByName('tile'+i+j));

					
					dx = stage.stageWidth/2-i;
					dy = stage.stageHeight/2-j;
					radius = (Math.sqrt(dx*dx + dy*dy));
					
					//Get Pixel sur le BitmapData du PerlinNoise
					pixel = noiseBMD.getPixel(i,j);
					
					//calcul de la luminosité de chaque pixel
					brightness = pixel / 0xFFFFFF;
					angle = 360 * brightness;
					
					//Color
					ball.transform.colorTransform = new ColorTransform(red*brightness,green*brightness,blue*brightness,1, 1, 1, 0, 0);
					
					//Scale proportionnellement é la luminositédu pixel 
					ball.scaleX = ball.scaleY = (brightness/2);

				}
			}
		}
	}
}